//App.cpp
#include "App.h"

class EqualerByName
{
    string name;
public:
    EqualerByName(string name)
    {
        this->name = name;
    }
    bool operator()(const Genre *genre)const
    {
        if(genre==0)
        {
            return false;
        }
        return name.compare(genre->GetName())==0;
    }
};

App::App(void)
{
    cout<<"ִ 帣 ȣ:";
    max_genres = ehglobal::getnum();
    genres.resize(max_genres,0);//max_genres ŭ 0 ()
}


App::~App(void)
{
    for(int i = 0; i<max_genres; i++)
    {
        if(genres[i])
        {
            delete genres[i];
        }
    }
}

void App::Run()
{
    int key=NO_DEFINED;
    while((key = SelectMenu())!=ESC)
    {
        switch(key)
        {
        case F1: AddGenre(); break;
        case F2: RemoveGenreByNum(); break;
        case F3: RemoveGenreByName(); break;
        case F4: FindGenreByNum(); break;
        case F5: FindGenreByName(); break;
        case F6: ListGenre(); break;
        default: cout<<"߸ ϼ̽ϴ."<<endl; break;
        }
        cout<<"ƹ Ű ."<<endl;
        ehglobal::getkey();
    }
}

int App::SelectMenu()
{
    ehglobal::clrscr();//ܼ ȭ 
    cout<<"帣  α׷ [ESC]: "<<endl;
    cout<<"F1: 帣 ߰ F2: ȣ 帣  F3: ̸ 帣 "<<endl;
    cout<<"F4: ȣ 帣 ˻ F5: ̸ 帣 ˻ F6: 帣  "<<endl;

    return ehglobal::getkey();//ڰ Է  Ű ȯ
}

void App::AddGenre() //帣 ߰
{
    int num=0;
    cout<<"߰ 帣 ȣ(1~"<<max_genres<<"):";
    num = ehglobal::getnum();
    if((num<=0)||(num>max_genres))
    {
        cout<<"ȿ 帣 ȣ ƴմϴ."<<endl;
        return;
    }
    if(genres[num-1])//  ȿϸ(0 ƴϸ)
    {
        cout<<"̹ ֽϴ."<<endl;
        return;
    }
    cout<<"߰ 帣:";
    string name = ehglobal::getstr();//帣 Է
    Genre *genre = new Genre(num,name); //帣 
    genres[num-1] = genre;//
}



void App::RemoveGenreByNum()//ȣ 帣 
{
    int num=0;
    cout<<" 帣 ȣ(1~"<<max_genres<<"):";
    num = ehglobal::getnum();
    if((num<=0)||(num>max_genres))
    {
        cout<<"ȿ 帣 ȣ ƴմϴ."<<endl;
        return;
    }
    if(genres[num-1]==0)//  0̸
    {
        cout<<"ϴ."<<endl;
        return;
    }
    
    delete genres[num-1];
    genres[num-1]=0; //ʱⰪ     
}

void App::RemoveGenreByName()//̸ 帣 
{
    string name;
    cout<<" 帣:";
    name = ehglobal::getstr();
    EqualerByName ebname(name);

    GIter seek = find_if(genres.begin(), genres.end(), ebname);
    if(seek != genres.end())
    {
        Genre *genre = (*seek);
        int num = genre->GetNum();        
        delete genre;
        genres[num-1] = 0;
        cout<<"Ͽϴ."<<endl;
    }
    else
    {
        cout<<" ʴ 帣Դϴ."<<endl;
    }
}
void App::FindGenreByNum()const //ȣ 帣 ˻
{
    int num=0;
    cout<<"˻ 帣 ȣ(1~"<<max_genres<<"):";
    num = ehglobal::getnum();
    if((num<=0)||(num>max_genres))
    {
        cout<<"ȿ 帣 ȣ ƴմϴ."<<endl;
        return;
    }
    if(genres[num-1]==0)//  0̸
    {
        cout<<"ϴ."<<endl;
        return;
    }
    genres[num-1]->View();
}
void App::FindGenreByName()const //̸ 帣 ˻
{
    string name;
    cout<<"˻ 帣:";
    name = ehglobal::getstr();
    EqualerByName ebname(name);

    GCIter seek = find_if(genres.begin(), genres.end(), ebname);
    if(seek != genres.end())
    {
        Genre *genre = (*seek);
        genre->View();
    }
    else
    {
        cout<<" ʴ 帣Դϴ."<<endl;
    }
}
void App::ListGenre()const //帣  
{    
    for(int i = 0; i<max_genres; i++)
    {
        if(genres[i])
        {
            genres[i]->View();
        }
    }
}